! -*- F90 -*-
BEGIN_PROVIDER [real*8, distmat, (natom,natom)]
        implicit none
        integer :: iat,jat
        real*8 :: dist
        
        do iat=1,natom
         do jat=1,natom
          distmat(iat,jat)=dist(posat(1,iat),posat(1,jat))
!         write(6,*) ' dist ',iat,jat,distmat(iat,jat)
         end do
        end do
END_PROVIDER

 BEGIN_PROVIDER [real*8, Fijblock, (3,3) ]
&BEGIN_PROVIDER [real*8, Fmatrix, (3*natom,3*natom) ]
        implicit none
        integer :: i,j,iat,jat,ioff,joff
        real*8 :: ri(3),rij(3),rijabs,massi,massj,massfac,qi,qj,zi,zj
        real*8 :: interpol,rij2abs,rij3abs,prefactor,dist

        do i=1,3*natom
         do j=1,3*natom
          Fmatrix(i,j)=0.D0
         end do
        end do

        do iat=1,natom
         massi=elmass(nz(iat))
         if (massi.eq.0) then
          write(6,*) ' mass for element No ',nz(iat),' is not defined'
          write(6,*) ' please provide in source file <elements.irp.f>' 
          stop ' missing element mass '
         end if
         do i=1,3
          ri(i)=posat(i,iat)
         end do
!
! block F_iat - derivative_jat
!
         do jat=iat+1,natom
          massj=elmass(nz(jat))
          if (massj.eq.0) then
           write(6,*) ' mass for element No ',nz(jat),' is not defined'
           write(6,*) ' please provide in source file <elements.irp.f>' 
           stop ' missing element mass '
          end if
          massfac=1.D0/sqrt(massi*massj)
          rijabs=distmat(iat,jat)
          rij2abs=rijabs*rijabs
          rij3abs=rijabs*rij2abs
!         write(6,*) ' rijabs, massfac ',rijabs, massfac
!         write(6,*) ' atomtypes ',atomtype(iat),atomtype(jat)
          do i=1,3
           rij(i)=ri(i)-posat(i,jat)
          end do

          if (bavard) write(6,*)
          if (bavard) write(6,*) ' I Matrix block for atoms ',iat,jat
! the prefactor of the charges
          qj=interpol(rijabs,atomtype(jat))
          qi=interpol(rijabs,atomtype(iat))
          prefactor=dble(nz(iat)*nz(jat))-0.5D0*(nz(iat)*qj+nz(jat)*qi)
! insert  2 and 1/R^3 into the prefactor
          prefactor*= -2.D0/rij3abs
       
! now we have everything together for calculating the matrix element
          do i=1,3
           do j=1,3
            Fijblock(i,j)=prefactor*rij(i)*rij(j)/rij2abs
           end do
          end do

          if (bavard) then
           write(6,*) ' II Matrix block for atoms ',iat,jat
           do i=1,3
            write(6,'(3F20.12)') (Fijblock(i,j),j=1,3)
           end do
          end if
! save the block in the right (off-diagonal) place 
          ioff=3*(iat-1)
          joff=3*(jat-1)
! 
          do i=1,3
           do j=1,3
! save the block in the right (off-diagonal) place 
! weight with massfactor 1/sqrt(m_i m_j)
            Fmatrix(ioff+i,joff+j) =Fijblock(i,j)*massfac
            Fmatrix(joff+i,ioff+j) =Fijblock(i,j)*massfac
!  subtract the block as well in the diagonal block iat and jat
!  these have to be weighted with the masses of i and j
            Fmatrix(ioff+i,ioff+j)-=Fijblock(i,j)/massi
            Fmatrix(joff+i,joff+j)-=Fijblock(i,j)/massj
           end do
          end do
! close the loops over iat and jat
         end do
        end do
         
!       write(6,*)
!       write(6,*) ' the complete matrix '
!       do i=1,ndim
!        write(6,'(9f9.5)') (fmatrix(i,j),j=1,ndim)
!       end do
!       write(6,*)
        call timing('Fmat')
END_PROVIDER

