! -*- F90 -*-
 BEGIN_PROVIDER [character*48, filename ]
&BEGIN_PROVIDER [integer, filenamelength ]
      implicit none
      integer :: i,strlen
      write(6,*) ' please give a filename '
      read(5,'(A)') filename 
      filenamelength=strlen(filename)
END_PROVIDER

 BEGIN_PROVIDER [integer, natom]
&BEGIN_PROVIDER [character*80, title]
&BEGIN_PROVIDER [integer, titlelength]
       implicit none
       integer :: strlen
       open(unit=12,file=filename(1:filenamelength) &
            ,status='old',form='formatted')
       read(12,*) natom
       read(12,'(A80)') title
       titlelength=strlen(title)
       close(12)
END_PROVIDER

 BEGIN_PROVIDER [character*2, atomname, (natom) ]
&BEGIN_PROVIDER [real*8, posat, (3,natom)]
&BEGIN_PROVIDER [integer, nz, (natom)]
       implicit none
       integer :: i,j,ii
       character*2 :: ordername
       open(unit=12,file=filename(1:filenamelength) &
            ,status='old',form='formatted')
       read(12,*)
       read(12,*)
       do i=1,natom
        read(12,*) atomname(i),(posat(j,i),j=1,3)
        atomname(i)=ordername(atomname(i))
        nz(i)=-10
        do ii=1,92
         if (atomname(i).eq.elsymb(ii)) nz(i)=ii
        end do
        if (nz(i).eq.-10) then
         write(6,*) ' atom with symbol ',atomname(i), &
            ' not found in the list of elements'
         stop '       new element or wrong xyz format ?'
        end if
       end do
       close(12)
!      write(6,*) ' nz       = ',nz
       write(6,*) ' atomname = ',atomname
END_PROVIDER

       integer function strlen(str)
         implicit none
         character*(*) :: str
         integer :: i
         i=len(str)
         do while (str(i:i).eq.'')
          i=i-1
         end do
         strlen=i
       end function strlen

       real*8 function dist(a,b)
         implicit none
         real*8 :: a(3),b(3)
         integer :: i
         dist=0.D0
         do i=1,3
          dist+=(a(i)-b(i))*(a(i)-b(i))
         end do
         dist=sqrt(dist)
       end function dist

 BEGIN_PROVIDER [logical*1, elempresent, (92) ]
&BEGIN_PROVIDER [integer, ntypes]
&BEGIN_PROVIDER [integer, atomtype, (natom)]
      implicit none
      integer :: i
      do i=1,92
       elempresent(i)=.false.
      end do
      do i=1,natom
       elempresent(nz(i))=.true.
      end do
      ntypes=0
      do i=1,92
       if (elempresent(i)) ntypes=ntypes+1
      end do
END_PROVIDER

 BEGIN_PROVIDER [real*8, densities, (1000,2,ntypes) ]
&BEGIN_PROVIDER [integer, elemtype, (ntypes) ]
&BEGIN_PROVIDER [integer, atomtype, (natom) ]
BEGIN_DOC
! the needed atomic densities are read from files Symbol.atdens
! in fact integrated densities
! as x, y on a radial grid of 1000 points
END_DOC
       implicit none
       integer :: i,itype,fnl,iat,ii
       character*9 :: fname
       real*8 :: xdum,rlim,dr
       logical :: lread

       write(6,*)
       itype=0
       do i=1,92
        if (elempresent(i)) then
!        write(6,*) ' element No ',i,' is present '
         itype=itype+1
         elemtype(itype)=i
         do iat=1,natom
          if (nz(iat).eq.i) then
           atomtype(iat)=itype
!          write(6,*) ' atomtype(',iat,') = ',atomtype(iat)
          end if
         end do
        end if
       end do
       if (itype.ne.ntypes) stop ' something went wrong -- itype '
       do itype=1,ntypes
        if (elsymb(elemtype(itype))(2:2).eq.' ') then
         fname=elsymb(elemtype(itype))(1:1)//'.atdens'
         fnl=8
        else
         fname=elsymb(elemtype(itype))//'.atdens'
         fnl=9
        end if
        open(unit=12,file=fname(1:fnl),status='old',form='formatted')
        read(12,*)
        lread=.true.
! fill all places with the total number of electrons
        do i=1,1000
         densities(i,2,itype)=dble(elemtype(itype))
        end do
! read the initial data, not necessarily all places
        i=1
        do while (lread)
         read(12,*,end=200) densities(i,1,itype),xdum,densities(i,2,itype)
         i=i+1
         go to 210
  200    continue
         lread=.false.
  210    continue
        end do
        close(12)
! continue the radial values
        dr=densities(i-1,1,itype)-densities(i-2,1,itype)
        rlim=densities(i-1,1,itype)
        do ii=i,1000
         rlim=rlim+dr
         densities(ii,1,itype)=rlim
        end do
        write(6,*) ' read density for element ',elsymb(elemtype(itype))
       end do
! densities were tabulated in bohr, transform to Angstrom
       do itype=1,ntypes
        do i=1,1000
         densities(i,1,itype)*=antoau
        end do
       end do
       write(6,*)
       write(6,*) ' densities are ready '
       write(6,*)
END_PROVIDER

