! -*- F90 -*-
!
      real*8 function interpol(xval,itype)
        implicit none
        integer :: i,ii,ixa,itype
        real*8 :: p,e,f,g,h,f2,xa,xval
!
! we take 8 points, 4 to the left, 4 to the right
! in the dataset itype
! with these we fill the data array xdat, ydat and run 
! the interpolation with smoothing parameter 0
!
        if (bavard) write(6,*) ' called interpol with ',xval,itype
        i=1
        do while (densities(i,1,itype).lt.xval)
         i=i+1
         if (i.eq.1000) exit
        end do

        if (i.le.ndat/2) i=ndat/2+1
        if (i.eq.1000) then
         interpol=0.D0
         if (bavard) write(6,*) ' xval outside the data range ',xval,itype
         return
        end if

        do ii=1,ndat
         xdat(ii)=densities(i+ii-ndat/2-1,1,itype)
         ydat(ii)=densities(i+ii-ndat/2-1,2,itype)
!        write(6,'(i4,2f20.12)') ii,xdat(ii),ydat(ii)
        end do

!
! C.H.REINSCH, NUMERISCHE MATHEMATIK 10 (1967) 177
! ORIGINAL: ALGOL
!
! INITIALISIEREN
!
        P=0.D0
        Rspl(0)=0.D0
        Rspl(1)=0.D0
        R1spl(NDAT)=0.D0
        R2spl(NDAT)=0.D0
        R2spl(NDAT+1)=0.D0
        Uspl(0)=0.D0
        Uspl(1)=0.D0
        Uspl(NDAT+1)=0.D0
        Uspl(NDAT)=0.D0
!
! S=1 SOLLTE LINEARE REGRESSION GEBEN
!
!     YR=MAX(YDAT(0:NDAT-1))-MIN(YDAT(0:NDAT-1))
!     XR=MAX(XDAT(0:NDAT-1))-MIN(XDAT(0:NDAT-1))
!     S=S*DOUBLE(NDAT)*YR/XR
!
        H= XDAT(2)-XDAT(1)
        F=(YDAT(2)-YDAT(1))/H
        DO I=2,NDAT-1 
         G=H
         H=XDAT(I+1)-XDAT(I)
         E=F
         F=(YDAT(I+1)-YDAT(I))/H
         Aspl(I)=F-E
         Tspl(I)=2.D0*(G+H)/3.D0
         T1spl(I)=H/3.D0
         R2spl(I)=1.D0/G
         Rspl(I)=1.D0/H
         R1spl(I)=-1.D0/G-1.D0/H
        end DO
        DO I=2,NDAT-1
         Bspl(I)=Rspl(I)*Rspl(I)+R1spl(I)*R1spl(I)+R2spl(I)*R2spl(I)
         Cspl(I)=Rspl(I)*R1spl(I+1)+R1spl(I)*R2spl(I+1)
         Dspl(I)=Rspl(I)*R2spl(I+2)
        end DO
        F2=-smooth
!
1000    CONTINUE
        DO I=2,NDAT-1
         R1spl(I-1)=F*Rspl(I-1)
         R2spl(I-2)=G*Rspl(I-2)
         Rspl(I)=1.D0/(P*Bspl(I)+Tspl(I)-F*R1spl(I-1)-G*R2spl(I-2))
         Uspl(I)=Aspl(I)-R1spl(I-1)*Uspl(I-1)-R2spl(I-2)*Uspl(I-2)
         F=P*Cspl(I)+T1spl(I)-H*R1spl(I-1)
         G=H
         H=Dspl(I)*P
        END DO
        DO  I=NDAT-1,2,-1
         Uspl(I)=Rspl(I)*Uspl(I)-R1spl(I)*Uspl(I+1)-R2spl(I)*Uspl(I+2)
        end DO
        E=0.D0
        H=0.D0
        DO I=1,NDAT-1
         G=H
         H=(Uspl(I+1)-Uspl(I))/(XDAT(I+1)-XDAT(I))
         Vspl(I)=(H-G)
         E=E+Vspl(I)*(H-G)
        END DO
        Vspl(NDAT)=-H
        G=Vspl(NDAT)
        E=E-G*H
        G=F2
        F2=E*P*P
        IF ((F2.GE.smooth).OR.(F2.LE.G)) GO TO 110
        F=0.D0
        H=(Vspl(2)-Vspl(1))/(XDAT(2)-XDAT(1))
        DO I=2,NDAT-1 
         G=H
         H=(Vspl(I+1)-Vspl(I))/(XDAT(I+1)-XDAT(I))
         G=H-G-R1spl(I-1)*Rspl(I-1)-R2spl(I-2)*Rspl(I-2)
         F=F+G*Rspl(I)*G
         Rspl(I)=G
        END DO
        H=E-P*F
        IF (H.LE.0.D0) GO TO 110
        P=P+(smooth-F2)/((SQRT(smooth/E)+P)*H)
        GO TO 1000
110     CONTINUE
        
        DO I=1,NDAT
         Aspl(I)=YDAT(I)-P*Vspl(I)
         Cspl(I)=Uspl(I)
        END DO
        DO I=1,NDAT-1
         H=XDAT(I+1)-XDAT(I)
         Dspl(I)=(Cspl(I+1)-Cspl(I))/(3.D0*H)
         Bspl(I)=(Aspl(I+1)-Aspl(I))/H - (H*Dspl(I)+Cspl(I))*H
        END DO
!     
!     OUTPUT
!     
        XA=XDAT(1)
        IXA=1
        IF ((xval.GE.XDAT(IXA+1)).AND.(IXA.LT.NDAT-1)) THEN
         IXA=IXA+1
         XA=XDAT(IXA)
        END IF
        H=Xval-XA
        interpol=((Dspl(IXA)*H+Cspl(IXA))*H+Bspl(IXA))*H+Aspl(IXA)
      end function interpol
      
BEGIN_PROVIDER [ integer, ndat ]
      ndat=8
END_PROVIDER

 BEGIN_PROVIDER [ real*8, xdat, (ndat) ]
&BEGIN_PROVIDER [ real*8, ydat, (ndat) ]
END_PROVIDER

BEGIN_PROVIDER [ real*8, smooth ]
     smooth=0.D0
END_PROVIDER

 BEGIN_PROVIDER [ real*8, Aspl, (NDAT) ]
&BEGIN_PROVIDER [ real*8, Bspl, (NDAT) ]
&BEGIN_PROVIDER [ real*8, Cspl, (NDAT) ]
&BEGIN_PROVIDER [ real*8, Dspl, (NDAT) ]
&BEGIN_PROVIDER [ real*8, Rspl, (0:NDAT+1) ]
&BEGIN_PROVIDER [ real*8, Tspl, (0:NDAT+1) ]
&BEGIN_PROVIDER [ real*8, Uspl, (0:NDAT+1) ]
&BEGIN_PROVIDER [ real*8, Vspl, (0:NDAT+1) ]
&BEGIN_PROVIDER [ real*8, T1spl, (0:NDAT+1) ]
&BEGIN_PROVIDER [ real*8, R1spl, (0:NDAT+1) ]
&BEGIN_PROVIDER [ real*8, R2spl, (0:NDAT+1) ]
       implicit none
       integer :: i
       do i=1,ndat
        Aspl(i)=0.d0
        Bspl(i)=0.d0
        Cspl(i)=0.d0
        Dspl(i)=0.d0
       end do
       do i=0,ndat+1
        Rspl (i)=0.d0
        Tspl (i)=0.d0
        Uspl (i)=0.d0
        Vspl (i)=0.d0
        T1spl(i)=0.d0
        R1spl(i)=0.d0
        R2spl(i)=0.d0
       end do
END_PROVIDER
