! -*- F90 -*-
      program main
        call dating(pname,1)
        call header
        call timing('head')
        call driver
        call timing('all ')
        call dating(pname,2)
      end program main

      subroutine header
        write(6,*) 
        write(6,*) ' vibrational frequencies from atom densities '
        write(6,*) '   idea Patrick Chaquin, program Peter Reinhardt '
        write(6,*) '        LCT, Paris, juillet 2015 '
        write(6,*) '        using IRPF90 preprocessor '
        write(6,*) 
      end subroutine header

      subroutine driver
        implicit none
        integer :: i,j,itype
        real*8 :: xval,interpol,yval

        write(6,*)
        write(6,*) ' title read from input file '
        write(6,*) title(1:titlelength)
        write(6,*)
        write(6,*) ' atoms, type, nucl. charge and position (Angstr.)'
        do i=1,natom
         write(6,9901) i,atomname(i),nz(i),(posat(j,i),j=1,3)
        end do
9901    format(i4,'   ',A2,i6,3F20.12)
        write(6,*)
        write(6,*) 
        write(6,*) ' obtained frequencies '
        do i=1,ndim
         write(6,*) i,sqrt(abs(frequencies(i)))*freqmul
        end do
        if (wcoord) then
        write(6,*) 
        write(6,*) ' obtained normal coordinates '
         write(6,*) 
        do i=1,ndim
         write(6,9701) i,sqrt(abs(frequencies(i)))*freqmul
9701 format(' frequency ',i4,F12.3,' cm-1')
         write(6,*)  ' normal coordinate '
         write(6,'(A2,3F20.12)') (atomname(j),normcoord(3*(j-1)+1,i), &
             normcoord(3*(j-1)+2,i),normcoord(3*(j-1)+3,i),j=1,natom)
         write(6,*) 
        end do
        end if
      end subroutine driver
